// #![feature(test)]

// extern crate test;

pub use common::cook::cook;

pub mod common;

#[cfg(test)]
mod tests {
    use super::*;

    // use test::Bencher;

    #[test]
    fn cook_test() {
        let input = r#"《阿波罗分！〈利窍〉——你（看看！）三三，》：
“芝加：‘他说了「谱」（起立）’哥，”土气。算法……
过去？来；自己拿“好的”，年【月】～【在】！
（费）

  "#;
        let expected_trimmed_output = r#"《阿波罗分! 〈利窍〉- 你 (看看!) 三三,》:
"芝加: '他说了 '谱'(起立)' 哥," 土气. 算法...
过去? 来; 自己拿 "好的", 年 [月] ~ [在]!
(费)"#;
        assert_eq!(expected_trimmed_output, cook(input));
    }

    //     #[bench]
    //     fn cook_bench(b: &mut Bencher) {
    //         b.iter(|| {
    //           let input = r#"美国宇航局（NASA；美国太空总署）价值100亿美元的最新太空望远镜拍下了“恒星托儿所”与“宇宙之舞”的震撼影像。

    // 詹姆斯·韦伯（James Webb）太空望远镜被称为知名的哈勃（Hubble）望远镜的继承者。它拍摄的首批全彩色宇宙照片公诸于世。

    // 美国总统拜登（Joe Biden）星期一（7月11日）公布了一张显示极远距离星系的照片作为预告。

    // 参与此项目的科学家正跟进其他照片，以验证韦伯望远镜的广泛用途。

    // 这台新望远镜被特别调校，可以用红外线观测天空——那是人类肉眼能感应得到但波长较长的光束。

    // 这让新望远镜比上一代更有能力望向宇宙深处，从而探测到更远古的事件——即超过135亿年以前。

    // 天文学家预料还将利用新望远镜上更为先进的技术，来研究遥远星体的大气层，以期探测到生命迹象。

    // 参与领导研究韦伯望远镜上四组红外仪器之一的英国专家吉莉安·赖特教授（Prof Gillian Wright）说，首批照片只属初试啼声，陆续有来。

    // 她说：“每当你用崭新方法来看星空，你总会看到让你意想不到的事物。”

    // 身兼英国天文学技术中心主任的赖特教授对BBC说：“这些新数据非常好，质量很好，而且只花了几个小时观测便得到了——这说明你想要发现的都在那，就等你去发现。”

    // SMACS 0723星系

    // 这些银河系的光束经历了数十亿光年才能来到我们面前。

    // SMACS 0723是一个巨大的星系团，其质量好到能够使星系团折射并放大来自更远地方的光束，被天文学家称为“引力透镜”（gravitational lens）。从哪里都能看见其红色弧形结构——那是重点：就是一个星系。这不但是来自远方，更来自更加远古时期。

    // 部分弧形的光束花了130亿年才传送到我们面前。这里还有一件怪事，照片两边出现的部分弧形其实是同一个物体，它们的光束以多于一条线路穿越SMACS 0723星体群。

    // 南环星云（The Southern Ring）

    // 分别以近红外（Near-infrared；左）和中红外（Mid-infrared；右）拍摄的南环星云照片。

    // 你大概会在那些有关哈勃望远镜所拍摄图像的桌边书（coffee table books）里面看过差不多的照片。南环星云，或称“八裂星云”，是个巨型的气体与尘埃球体，中间由一颗正在衰败的星体照亮。随着星体老化，它们改变自身产生能量的方式，并排斥其外层。

    // 当星体再次变得炽热，便会燃烧它此前排出的所有物质。

    // 南环星云直径将近半个光年，位于地球外约2000光年处。这种星群被称为“行星状星云”（planetary nebula），但其实与星球无关。那是早期望远镜观星者因解析度不足，进而用词不当所致。韦伯望远镜试图观测星体如何诞生，同样也希望观测星体如何衰亡。

    // 斯蒂芬五重星系（Stephan's Quintet）

    // 斯蒂芬五重星系照片：左为韦伯望远镜所摄，右为哈勃望远镜所摄。

    // 斯蒂芬五重星系位于大约在2.9亿光年外的飞马座（Pegasus），是首个被人类发现的星系团。星系群内五个星系中，有四个被困在重复靠近彼此的“宇宙之舞”当中。

    // 这张由韦伯望远镜所拍摄的照片，看上去跟由哈勃望远镜所拍摄的分别不大。但新望远镜的红外线敏感度更高，能捕捉各种特征供天文学家研究。这是一个重大盼望——韦伯望远镜能与哈勃望远镜同时运作。它们各有所长，对比两者照片，可给科学家的研究提供新维度。

    // 我们不知道哈勃望远镜还能工作多久，它已有32年历史，容易故障。但负责照顾这匹“老战马”的美国宇航局官员才刚递交新的五年预算。祝大家好运。

    // 船底座星云（Carina Nebula）

    // 船底座星云是哈勃望远镜的典型目标，而这张韦伯望远镜版本的照片呈现了与众不同的面貌。

    // 船底座是天空上数一数二庞大而又明亮的星云，距离地球约7600光年。船底座是“恒星托儿所”，是一团庞大的气体和灰尘，新的星体会在此诞生。

    // 不过在这张韦伯望远镜的照片中，我们不怎么能看到星体，只有气体和灰尘。天文学家把这称为“宇宙礁”（cosmic reef），是一种分界线，底层是灰尘，上层是气体。

    // 韦伯望远镜的关键科学目标之一，是要研究星体如何形成，而船底座是进行此研究的上佳地点。

    // 曾经被称为“币圈茅台”的 Terra (LUNA) 加密币突然崩盘，震波殃及许多其他数字币，包括群内龙头比特币。

    // 世界各地被“割韭菜”的投资者愤怒绝望，Terra 区块链创办人和公司被警方立案侦查。

    // 断崖式贬值前几周，Terra 发行的姊妹币 LUNA 和美元计价的 UST 曾持续上涨。

    // 大起大落

    // LUNA币依托的 Terra 区块链平台是韩国人权道亨（Do Kwon）2018 年建立的，发行后最初两年价格一直在一美元以下浮动。2021 年 12 月开始崭露头角，币价开始上涨，从 5 美元升到今年 4 月的 116 美元，一度接近120美元，市值 410 亿美元，在所有加密币中排第五名。

    // 在 LUNA 币之后，Terra 又发行了一个跟美元 1：1 对标的稳定币，叫 UST，LUNA可以跟 UST 相互兑换，并为这个稳定币推出存款应用程序，在这个Anchor上存 UST 可以得到19.5% 的回报（年化收益）。

    // 如此丰厚的回报非常诱人，又因为两个Terra 平台发行的虚拟币可以相互兑换，于是出现很多投机套利交易。

    // UST 大部分泊在高收益 Anchor ，流动性很小，币价涨势基本保持了大约一年，直到一笔 8400万美元的抛售指令出现。

    // 引爆地雷

    // 其实，在币价双双起飞的同时，已经出现了这是否庞氏骗局的怀疑。

    // 5月8日，Terra 挪动1.5亿美元 UST 调整流动性，但10分钟后一个新地址突然抛售8400万美元的UST，随即引发抛售浪潮和恐慌情绪。当天，UST 价格顽固地滞留在 95 美分水平，进一步刺激了抛售潮。

    // 局势很快失控。UST 与美元加速脱钩，9日崩盘，48小时贬值99%。

    // 虚拟币投资圈的其他人见状惊恐，迅速从其他加密币市场撤退，带走数十亿美元。

    // 币圈热闹 加密数字币版图悄然改变

    // 脸书币Libra质疑声浪中亮相 不是比特币也不是支付宝

    // ”韭菜“的愤怒

    // 权道亨 30 岁，家住首尔，历来对媒体避之唯恐不及。Terra 双币崩盘后，无数投资者在社交媒体上追踪他，要求他出手救局。

    // 其中一位化名钱瑟斯（Chancers）的投资者绝望之下耗光了耐心，搜索到权家的地址，直接上门质询，并在网上直播整个过程，大约 100 人在线观看。

    // 钱瑟斯敲门，权道亨的妻子开门，告之丈夫不在家。很快，闻讯赶到现场的警察逮捕了钱瑟斯。

    // 据当地媒体报道，钱瑟斯声称自己并不知晓在首尔不请自来地到人家要求对话会触犯韩国法律，他还说自己已向警方自首。

    // 马斯克，中国矿工……一文看懂近期比特币大幅波动及背后原因

    // 中国加强打击加密货币后，比特币现恐慌式抛售

    // LUNA 币赖以存在的 Terra 区块链平台创始人之一权道亨（Do Kwon）。自从 Terra 双币崩盘后就从公众眼前消失了

    // 钱瑟斯对BBC记者乔·泰迪（Joe Tidy）说，他很可能会面临罚款和犯罪记录，而这可能会使他的生活变得困难。

    // 他说： ”我损失了很多钱，现在又在接受警方调查。我原本在韩国担任公务员，一旦被定罪，我可能无法重返公务员队伍。

    // ”在韩国文化中，这件事本身并不重要，重要的是它引发了丑闻。我甚至不得不以罪人的身份公开道歉。我不知道会这么严重。太悲催了。“

    // 他指责权道亨在 Terra 币崩盘期间和之后没有与投资者充分沟通。他现在认为这件事就是个”骗局“。

    // 权道亨辩解说，他本人和公司都没有从 Terra 币崩溃中赚到一分钱。

    // 公司”死了“

    // 5月20日，韩国警方宣布对 Terra 币发行公司， Terraform Labs，展开调查。当地媒体报道称金融和证券犯罪联合调查组正在追踪 LUNA 币和 UST 币的下落。

    // 在 Terra 告终前一周，权道亨在 YouTube 加密币频道上宣称，“95% 的加密币将会消亡——但目睹公司消亡也是一种娱乐。”

    // LUNA 和 UST 崩溃前，他还在推特上向100万粉丝表示：“我喜欢混乱。”

    // 在接下来的三天里，他在一连串的推文中推出了一个又一个计划来救局，呼吁 Terra 社区”坚持不懈“。

    // 5 月 13 日，权道亨表示救援失败，在推特上声明：”我的发明给你们大家带来痛苦，令我心碎。“

    // 他又设计了一个有争议的计划来复活 Luna ，招致币圈知名人士的批评。

    // 加密币交易所币安首席执行官赵长鹏称这个计划是”一厢情愿“。

    // 加密币 Dogecoin 联合创始人比利·马库斯（Billy Markus）也在推特上严词厉色：”我的建议是停止引诱新的受害者入局来补偿以前的受害者，永远离开这个圈子。“

    // 权道亨和 Terraform Labs 公司均未回应BBC记者的置评请求。"#;
    //         });
    //     }
}
